<?php
/* ES/efg_firewall.inc
 *    PHP include script for efg.php,
 *    intended to show/deliver the actual firewall script
 *
 * 2014-03-27 v2.0.2 Added $MY_CIDR
 * 2014-03-22 v2.0.1 Added SYNACKANDNEW in bad_tcp_packets chain
 * 2014-03-18 v2.0.0 Released
 * 2014-02-27 v2.0.0 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: EN/efg_firewall.inc, v2.0.2 2014-03-27
 * @author Alex KEMP http://www.modem-help.co.uk/
 * @translator Alex KEMP (Google translate)
 *
 * (START original header)
 * Copyright 2002 Timothy Scott Morizot
 *
 * This file is part of my Easy Firewall Generator for IPTables.
 *
 * Easy Firewall Generator for IPTables is free software;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Easy Firewall Generator for IPTables is distributed
 * in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this distribution; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (next line now set by Conteg)
 * //Set type to plain text
 * header("Content-Type: text/plain");
 * (FINISH original header)
 *
 * script transcribed to avoid use of untested '$_POST()' variables
 */

?>
#!/bin/sh
#
###############################################################################
#
# Generado iptables script de firewall para Linux 2.4, 2.6 + kernel tarde
<?php
	print "# Script generado por Easy Firewall Generador de IPTables $VERSION
# (v2.0.0 basada directamente en v1.17 originales EFG)
# This version     : copyright $YEAR_NOW Modem-Help, Ltd. ($HOME)
# Translation (ES) : copyright $YEAR_NOW Garry Ricketson
# Previous versions: copyright 2002 Timothy Scott Morizot (easyfwgen.morizot.net)
#
# Generated        : $NOW
";
?>
#
# Redhat comentarios chkconfig - cortafuegos aplicado temprano,
#                                Eliminado finales
# chkconfig: 2345 08 92
# Descripción: Este script se aplica o elimina reglas de iptables firewall
#
# Ajustes utilizados:
<?php
	print "# INET_IFACE: $INET_IFACE
# IP de Internet: ". (( $DYNAMIC_IP )
	? $DYNAMIC_IP_YES_TITLE[ $_LANG ]
	: "{$DYNAMIC_IP_NO_TITLE[$_LANG]} ($INET_ADDRESS)"
) ."
#      Ordenador: ". (( $GATEWAY )
	? "{$GATEWAY_YES_TITLE[$_LANG]}
#             LOCAL_IFACE: $LOCAL_IFACE
#                LOCAL_IP: $LOCAL_IP
#               LOCAL_NET: $LOCAL_NET
#             LOCAL_BCAST: $LOCAL_BCAST"
	: $GATEWAY_NO_TITLE[ $_LANG ]
) ."
#            Red: ". (( $SPECIAL_LAN )
	? (
		( $BLOCK_OUTBOUND )		? "({$BLOCK_OUTBOUND_TITLE[$_LANG]})"		: '').
		(( $INTERNAL_DHCP )		? "({$INTERNAL_DHCP_TITLE[$_LANG]})"		: '').
		(( $MANGLE_TTL )			? "({$MANGLE_TTL_TITLE[$_LANG]})"			: '').
		(( $PORT_FORWARD )		? "({$PORT_FORWARD_TITLE[$_LANG]})"			: '').
		(( $TRANSPARENT_PROXY )	? "({$TRANSPARENT_PROXY_TITLE[$_LANG]})"	: ''
	)
	: '(ninguno)'
) ."
#       Permitir: ". (( $INBOUND_ALLOW )
	? (
		( $SELF_IN )				? "({$SELF_NET_TITLE[$_LANG]})"				: '').
		(( $DHCP_IN )				? "({$DHCP_IN_TITLE[$_LANG]})"				: '').
		(( $DNS_IN )				? "({$DNS_IN_TITLE[$_LANG]})"					: '').
		(( $IM_IN )					? "({$IM_IN_TITLE[$_LANG]})"					: '').
		(( $HTTP_IN )				? "({$HTTP_IN_TITLE[$_LANG]})"				: '').
		(( $FTP_IN )				? "({$FTP_IN_TITLE[$_LANG]})"					: '').
		(( $EMAIL_IN )				? "({$EMAIL_IN_TITLE[$_LANG]})"				: '').
		(( $NTP_IN )				? "({$NTP_IN_TITLE[$_LANG]})"					: '').
		(( $MDNSRESPONDER_IN )	? "({$MDNSRESPONDER_IN_TITLE[$_LANG]})"	: '').
		(( $MESSENGER_IN )		? "({$MESSENGER_IN_TITLE[$_LANG]})"			: '').
		(( $NFS_IN )				? "({$NFS_IN_TITLE[$_LANG]})"					: '').
		(( $OTHER_IN )				? "({$OTHER_IN_TITLE[$_LANG]})"				: '').
		(( $SSH_IN )				? "({$SSH_IN_TITLE[$_LANG]})"					: ''
	)
	: '(ninguno)'
) ."
#      Fireparse: ". (( $LOG_FIREPARSE )
	? 'Yes'
	: 'No'
) ."
#    Usuario IRC: ". (( $IRC_USER )
	? 'Yes'
	: 'No'
). "\n";
?>
#
# Este generador está diseñado principalmente para las instalaciones
# de RedHat, aunque debe ser adaptable para otros.
#
# Se puede ejecutar con el inicio y parada típica argumentos.
# Si utiliza con parada, se detendrá después de tirar el servidor de seguridad.
# Los argumentos de salvar y restaurar salvarán o restaurar las reglas desde
# el fichero /etc/sysconfig/iptables. Los argumentos de salvar y restaurar
# se incluyen para mantener la compatibilidad con Redhat o script de init.d
# de Fedora para que pueda utilizarlo.

# Instrucciones de instalación RedHat / Fedora / CentOS
#
# 1. Tener el sistema de enlace de las iptables init.d script de inicio en
#    los estados de ejecución 2, 3 y 5.
#    chkconfig --level 235 iptables on
#
# 2. Guarde este script y ejecutarlo para cargar el conjunto de reglas de este
#    archivo. Es posible que tenga que ejecutar el comando dos2unix en él para
#    eliminar los retornos de carro.
#
# 3. Para que se aplicaba en el arranque, copie este script en /etc/init.d/iptables.
#    Acepta 'stop' (detener), 'start' (iniciar), 'save' (guardar) y 'restore'
#    (restaurar) argumentos. (Es posible que desee guardar antes la primera.)
#    Por otra parte, si se emite el 'service iptables save' el guión init.d
#    debe guardar las reglas y volver a cargarlos en tiempo de ejecución.
#
# 4. Para los sistemas no Redhat (o sistemas Redhat si usted tiene un problema),
#    es posible que desee agregar el comando a ejecutar este script para rc.local.
#    rc.local normalmente se encuentra en /etc y /etc/rc.d y suele ser lo último
#    que se ejecuta en el arranque. Basta con añadir /ruta/al/script/script_nombre
#    en su propia línea en el archivo rc.local.

###############################################################################
#
# Configuración local
#

# Ubicación sysctl: Si se establece, se utilizará sysctl para ajustar los
# parámetros del kernel. Si se establece en la cadena vacía (o es desconectado),
# el uso de sysctl está desactivado.

SYSCTL="/sbin/sysctl -w"

# A repetir el valor directamente en el archivo /proc lugar
# SYSCTL=""

# IPTables Ubicación - ajustar si es necesario

IPT="/sbin/iptables"
IPTS="/sbin/iptables-save"
IPTR="/sbin/iptables-restore"

# Interfaz de Internet
<?php
print "INET_IFACE=\"$INET_IFACE\"\n";
print ( $DYNAMIC_IP )
	? ''
	: "INET_ADDRESS=\"$INET_ADDRESS\"\n";
print ( $GATEWAY )
	? "
# Información de la Interfaz local
LOCAL_IFACE=\"$LOCAL_IFACE\"
LOCAL_IP=\"$LOCAL_IP\"
LOCAL_NET=\"$LOCAL_NET\"
LOCAL_BCAST=\"$LOCAL_BCAST\"
"
	: '';
print ( $SELF_IN )
	? "
# Acceso administrador de la red
MY_CIDR=\"$SELF_NET\"
"
	: '';
?>

# Interfaz de Localhost

LO_IFACE="lo"
LO_IP="127.0.0.1"

# Guardar ('save') y Restaurar ('restore') los argumentos manejados aquí
if [ "$1" = "save" ]
then
	echo -n "Ahorrar firewall para /etc/sysconfig/iptables ... "
	$IPTS > /etc/sysconfig/iptables
	echo "hecho"
	exit 0
elif [ "$1" = "restore" ]
then
	echo -n "Restauración de firewall de /etc/sysconfig/iptables ... "
	$IPTR < /etc/sysconfig/iptables
	echo "hecho"
	exit 0
fi

###############################################################################
#
# Módulos de Carga
#

echo "Cargar módulos del kernel ..."

# Usted debe comentar la línea de abajo y correr la primera vez sólo para
# asegurarse de que todas las dependencias de módulos del kernel están bien.
# No hay necesidad de correr todo el tiempo, sin embargo.

# /sbin/depmod -a

# A menos que tenga kernel módulo de auto-carga desactivado, usted no debería
# tener que cargar manualmente cada uno de estos módulos. Aparte de ip_tables,
# ip_conntrack, y algunos de los módulos opcionales, he dejado estos comentada
# por defecto. Elimine el comentario de si tiene algún problema o si tiene
# desactivada módulo de carga automática. Tenga en cuenta que algunos módulos
# deben ser cargados por otro módulo del kernel.

# Módulo netfilter del núcleo
/sbin/modprobe ip_tables

# El módulo de seguimiento de conexiones con estado
/sbin/modprobe ip_conntrack

# Módulo de tabla de filtros
# /sbin/modprobe iptable_filter

# Módulo tabla mangle
# /sbin/modprobe iptable_mangle

# Módulo tabla nat
# /sbin/modprobe iptable_nat

# Módulo de destino LOG
# /sbin/modprobe ipt_LOG

# Esto se utiliza para limitar el número de paquetes por seg / min / hr
# /sbin/modprobe ipt_limit

# Mascarada módulo de destino
# /sbin/modprobe ipt_MASQUERADE

# Filtrar usando propietario como parte del partido
# /sbin/modprobe ipt_owner

# REJECT (rechazar) objetivo descarta el paquete y devuelve una respuesta ICMP.
# La respuesta es configurable. Por defecto, la conexión se negó.
# /sbin/modprobe ipt_REJECT

# Este objetivo permite que los paquetes están marcados en la tabla mangle
# /sbin/modprobe ipt_mark

# Este objetivo afecta el MSS de TCP
# /sbin/modprobe ipt_tcpmss

# Este partido permite que varios puertos en lugar de un único puerto o un rango
# /sbin/modprobe multiport

# Este partido cheques contra las banderas TCP
# /sbin/modprobe ipt_state

# Este partido atrapa paquetes con opciones no válidas
# /sbin/modprobe ipt_unclean

# Se requiere que el módulo de nat ftp apoyo ftp no PASV
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_nat_ftp

# El módulo para el seguimiento completo de conexión ftp
<?php
	print ( $FTP_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_ftp

# El módulo para el seguimiento completo de conexión IRC
<?php
	print ( $IRC_OUT )
		? '#'
		: '';
?>
/sbin/modprobe ip_conntrack_irc


###############################################################################
#
# Configuración de Parámetros del Kernel
#
# Consultar http://ipsysctl-tutorial.frozentux.net/chunkyhtml/index.html
# para un tutorial detallado sobre sysctl y las diversas opciones disponibles.

# Necesario para activar el reenvío de IPv4.
# Los usuarios de Redhat pueden intentar establecer FORWARD_IPV4 en
# /etc/sysconfig/network true.
# Alternativamente, se puede configurar en /etc/sysctl.conf
<?php
	print ( $GATEWAY )
		? "if [ \"\$SYSCTL\" = \"\" ]
then
    echo \"1\" > /proc/sys/net/ipv4/ip_forward
else
    \$SYSCTL net.ipv4.ip_forward=\"1\"
fi"
		: "#if [ \"\$SYSCTL\" = \"\" ]
#then
#    echo \"1\" > /proc/sys/net/ipv4/ip_forward
#else
#    \$SYSCTL net.ipv4.ip_forward=\"1\"
#fi";
?>


# Esto permite a la piratería dirección dinámica.
# Esto puede ayudar si usted tiene una dirección IP dinámica
# (por ejemplo, slip, ppp, dhcp).
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/ip_dynaddr
#else
#    $SYSCTL net.ipv4.ip_dynaddr="1"
#fi

# Esto permite la protección contra inundaciones SYN.
# La activación de las cookies SYN permite a su sistema para aceptar un número
# ilimitado de conexiones TCP, mientras que todavía está tratando de dar
# un servicio razonable durante un ataque de denegación de servicio.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/tcp_syncookies
else
    $SYSCTL net.ipv4.tcp_syncookies="1"
fi

# Esto permite la validación del origen por path inverso de acuerdo con RFC1812.
# En otras palabras, ¿El paquete de respuesta se originan desde la misma
# interfaz a través del cual se envió el paquete fuente? Se recomienda para
# los sistemas y routers individuales alojados en redes aisladas. Dado que esas
# son las configuraciones de este servidor de seguridad está diseñado
# para apoyar, lo enciendo de forma predeterminada. Apágalo si utiliza varias
# tarjetas de red conectados a la misma red.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/rp_filter
else
    $SYSCTL net.ipv4.conf.all.rp_filter="1"
fi

# Esta opción permite a una subred a un cortafuegos con una única dirección IP.
# Se utiliza para crear una DMZ. Dado que no es un tema central de este
# script de firewall, no está activado por defecto, pero se incluye como referencia.
# Consultar: http://www.sjdjweis.com/linux/proxyarp/
#if [ "$SYSCTL" = "" ]
#then
#    echo "1" > /proc/sys/net/ipv4/conf/all/proxy_arp
#else
#    $SYSCTL net.ipv4.conf.all.proxy_arp="1"
#fi

# La siguiente configuración del kernel fueron sugeridos por Alex Weeks. Gracias!

# Este parámetro indica al kernel kernel para ignorar todas las peticiones
# de eco ICMP enviados a la dirección de difusión. Esto evita que un número
# de los pitufos y los ataques de denegación de servicio desagradables similares.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
else
    $SYSCTL net.ipv4.icmp_echo_ignore_broadcasts="1"
fi

# Esta opción se puede utilizar para aceptar o rechazar los paquetes
# enrutados desde el origen. Por lo general, de forma predeterminada,
# pero en general se considera un riesgo de seguridad. Esta opción lo apaga.
if [ "$SYSCTL" = "" ]
then
    echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
else
    $SYSCTL net.ipv4.conf.all.accept_source_route="0"
fi

# Esta opción se puede desactivar la redirección ICMP. Redirecciones ICMP
# se consideran en general un riesgo de seguridad y no deben ser necesarios
# por la mayoría de los sistemas que utilizan este generador.
#if [ "$SYSCTL" = "" ]
#then
#    echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
#else
#    $SYSCTL net.ipv4.conf.all.accept_redirects="0"
#fi

# Sin embargo, nos aseguraremos la opción secure_redirects está en su lugar.
# Esta opción acepta sólo de puertas de enlace de la lista de puertas de
# enlace predeterminada.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/secure_redirects
else
    $SYSCTL net.ipv4.conf.all.secure_redirects="1"
fi

# Esta opción registra los paquetes provenientes de direcciones imposibles.
if [ "$SYSCTL" = "" ]
then
    echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
else
    $SYSCTL net.ipv4.conf.all.log_martians="1"
fi


###############################################################################
#
# Lave Todas las Reglas o Cadenas Existentes
#

echo "Tablas de Flushing ..."

# Restablecer políticas predeterminadas
$IPT -P INPUT ACCEPT
$IPT -P FORWARD ACCEPT
$IPT -P OUTPUT ACCEPT
$IPT -t nat -P PREROUTING ACCEPT
$IPT -t nat -P POSTROUTING ACCEPT
$IPT -t nat -P OUTPUT ACCEPT
$IPT -t mangle -P PREROUTING ACCEPT
$IPT -t mangle -P OUTPUT ACCEPT

# Lave todas las reglas
$IPT -F
$IPT -t nat -F
$IPT -t mangle -F

# Borra todas las cadenas no predeterminados
$IPT -X
$IPT -t nat -X
$IPT -t mangle -X

if [ "$1" = "stop" ]
then
	echo "Firewall enjuagar! Ahora se ejecuta con ningún cortafuegos."
	exit 0
fi

###############################################################################
#
# Reglas de Configuración
#

###############################################################################
#
# Filtrar Tabla
#
###############################################################################

# Establecer Políticas

$IPT -P INPUT DROP
$IPT -P OUTPUT DROP
$IPT -P FORWARD DROP

###############################################################################
#
# Cadenas Especificada por el Usuario
#
# Crear cadenas de usuario para reducir el número de reglas cada paquete
# debe atravesar.

echo "Crear y llenar las cadenas de reglas personalizadas ..."

# Crea una cadena para filtrar paquetes INVALID
$IPT -N bad_packets

# Cree otra cadena para filtrar los paquetes tcp incorrectos
$IPT -N bad_tcp_packets

# Crea cadenas separadas para ICMP, TCP (entrante y saliente),
# y los paquetes UDP entrantes.
$IPT -N icmp_packets

# Se utiliza para los paquetes UDP entrantes de Internet
$IPT -N udp_inbound

# Se utiliza para bloquear servicios UDP salientes desde la red interna
# Por defecto para permitir a todos
$IPT -N udp_outbound

# Se utiliza para permitir servicios de entrada, si se desea
# Por defecto falle a excepción de las sesiones establecidas
$IPT -N tcp_inbound

# Se utiliza para bloquear los servicios de salida de la red interna
# Por defecto para permitir a todos
$IPT -N tcp_outbound

###############################################################################
#
# Rellenar Cadenas de Usuario
#

###############################################################################
#
# cadena bad_packets
#
<?php
	// Rules for the private network
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $GATEWAY )
		? "
# Descartar paquetes recibidos en la interfaz externa
# reclamando una fuente de la red local
\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j LOG \
".		(( $LOG_FIREPARSE )
			? "    --log-prefix \"fp=bad_packets:2 a=DROP \""
			: "    --log-prefix \"Illegal source: \""
		). "

\$IPT -A bad_packets -p ALL -i \$INET_IFACE -s \$LOCAL_NET -j DROP
"
		: '';
?>

# Caiga INVALID (no válido) paquetes inmediatamente
$IPT -A bad_packets -p ALL -m state --state INVALID -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_packets:1 a=DROP \""
		: "    --log-prefix \"Invalid packet: \"";
?>


$IPT -A bad_packets -p ALL -m state --state INVALID -j DROP

# A continuación, compruebe los paquetes tcp de problemas adicionales
$IPT -A bad_packets -p tcp -j bad_tcp_packets

# Todo bien, así que regreso
$IPT -A bad_packets -p ALL -j RETURN

###############################################################################
#
# cadena bad_tcp_packets
#
# Todos los paquetes tcp atravesarán esta cadena.
# Cada nuevo intento de conexión debe comenzar con paquete SYN.
# Si no es así, lo más probable es un escaneo de puertos.
# Esto descarta los paquetes en el estado de nuevo que no
# están marcados como paquetes SYN.

<?php
	// If there is a gateway, exempt the internal interface.
	print ( $GATEWAY )
		? "
# Vuelva a la cadena de llamadas si los paquetes defectuosos se
# originan en la interfaz local. Esto mantiene el enfoque a través
# de este servidor de seguridad de una red interna en gran
# medida de confianza.
\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE -j RETURN

# Sin embargo, me hice originalmente aplicar este filtro a la
# cadena de reenvío para los paquetes procedentes de la red interna.
# Aunque no he concluido en determinar su efecto, pues parece
# que tiene el efecto secundario interesante de bloquear algunos de
# los sistemas de anuncios. Al parecer, algunos sistemas de anuncios
# tienen el navegador inicia una nueva conexión que no está marcado
# como un paquete SYN para recuperar la imagen del anuncio. Si desea
# experimentar más comentarios la regla anterior. Si lo intentas,
# te recomendamos también que descomentar la siguiente regla. Asimismo,
# mantendrá esos paquetes se registre. Hay un montón de ellos.
#\$IPT -A bad_tcp_packets -p tcp -i \$LOCAL_IFACE ! --syn -m state \\
#     --state NEW -j DROP
"
		: '';
?>

# 2014-03-22 adicional -AK
# Ley honrosamente en nombre de otras personas que reciben ataques
# de Predicción TCP número de secuencia (estos ataques se basan en el
# DROP anfitrión falso desconocidos SYN / ACK en lugar de rechazarlas).
# Ver https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#SYNACKANDNEW
$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,ACK SYN,ACK \
    -m state --state NEW -j REJECT --reject-with tcp-reset

# Fijar característica iptables de permitir que los paquetes con SYN NUEVO
# bit no establecido
# Ver https://www.frozentux.net/iptables-tutorial/iptables-tutorial.html#NEWNOTSYN
$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:1 a=DROP \""
		: "    --log-prefix \"New not syn: \"";
?>

$IPT -A bad_tcp_packets -p tcp ! --syn -m state --state NEW -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:2 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL NONE -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:3 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL ALL -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:4 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL FIN,URG,PSH -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:5 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:6 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,RST SYN,RST -j DROP

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=bad_tcp_packets:7 a=DROP \""
		: "    --log-prefix \"Stealth scan: \"";
?>

$IPT -A bad_tcp_packets -p tcp --tcp-flags SYN,FIN SYN,FIN -j DROP

# Todo bien, así que regreso
$IPT -A bad_tcp_packets -p tcp -j RETURN

###############################################################################
#
# icmp_packets cadena
#
# Esta cadena es sólo para los paquetes ICMP entrantes (de Internet).
# Tipo 8 (Echo Request) no es aceptado por defecto
# Habilitar si quieres hosts remotos puedan comunicarse con usted.
# 11 (Tiempo excedido) es el único aceptado que no ya estaría cubierto
# por la regla de conexión establecida.
# Aplicada a la entrada en la interfaz externa.
#
# Consultar: http://www.ee.siue.edu/~rwalden/networking/icmp.html
# para más información sobre los tipos de ICMP.
#
# Tenga en cuenta que la configuración con estado permiten que las
# respuestas a los paquetes ICMP. Estas normas permiten a los
# nuevos paquetes de los tipos especificados.

# Paquetes ICMP deben encajar en una trama de Capa 2, por lo que
# nunca deben ser fragmentados. Paquetes ICMP fragmentados son un
# signo típico de un ataque de denegación de servicio.
$IPT -A icmp_packets --fragment -p ICMP -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "    --log-prefix \"fp=icmp_packets:1 a=DROP \""
		: "    --log-prefix \"ICMP Fragment: \"";
?>

$IPT -A icmp_packets --fragment -p ICMP -j DROP

# Echo - descomentar para permitir que el sistema para hacer ping.
# Quitar el comando LOG si también desea registrar los intentos de PING
#
# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j LOG \
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "#    --log-prefix \"fp=icmp_packets:2 a=ACCEPT \""
		: "#    --log-prefix \"Ping detected: \"";
?>

# $IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j ACCEPT

# Por defecto, sin embargo, la caída de pings sin registro.
# Blaster y otros gusanos han infectado los sistemas de
# chorro de pings. Comentario la línea de abajo si quieres
# pings registrados, pero es probable que llenar sus registros.
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP

# Tiempo Agotado
$IPT -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j ACCEPT

# No coincide, por lo que volver por lo que se registrará
$IPT -A icmp_packets -p ICMP -j RETURN

###############################################################################
#
# TCP y UDP
# Identificar los puertos en:
#    http://www.chebucto.ns.ca/~rakerman/port-table.html
#    http://www.iana.org/assignments/port-numbers

###############################################################################
#
# cadena udp_inbound
#
# Esta cadena describe los paquetes UDP entrantes está dispuesta a aceptar.
# Se aplica a INPUT en la interfaz externa o Internet. Tenga en cuenta que
# la configuración con estado permiten respuestas. Estas reglas son para
# nuevas solicitudes. Suelta paquetes NetBIOS (Windows) inmediatamente
# sin iniciar sesión.

# Caiga llamadas netbios
# Tenga en cuenta que estas reglas realmente no cambian la forma en que
# trata a los cortafuegos conexiones NetBIOS. Las conexiones de la
# interfaz localhost e interno (si existe) son aceptadas de forma
# predeterminada. Las respuestas de la Internet a las peticiones iniciadas
# por oa través del servidor de seguridad también son aceptados por defecto.
# Para llegar hasta aquí, los paquetes deberían ser parte de una nueva
# solicitud recibida por la interfaz de Internet. Usted tendría que agregar
# manualmente las reglas para aceptar estos. He añadido estas reglas porque
# algunas conexiones de red, como los que a través de módems de cable,
# tienden a ser llenados con el ruido de las máquinas de Windows sin
# protección. Estas reglas eliminan los paquetes de forma rápida y sin
# necesidad de acceder ellos. Esto les impide atravesar toda la cadena y
# mantiene el registro de conseguir estorbado con chatter de sistemas Windows.
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 137 -j DROP
$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 138 -j DROP

<?php
	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# Peticiones IRC Ident (puerto 113) deben tener una regla de rechazo
# y no la regla DROP por defecto. Este es el requisito mínimo para
# evitar retrasos largos durante la conexión.
# Véase también la regla tcp_inbound.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j REJECT

# Una configuración más sofisticada podría aceptar las peticiones ident.
#\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Sin embargo, si se trata de un sistema de puerta de enlace que se disfraza
# / nats para los sistemas internos y los sistemas internos desean charlar,
# un simple cambio de estas reglas para ACCEPT (aceptar) no funcionará.
# El demonio ident en la puerta de entrada tendrá que saber cómo manejar
# las peticiones. El demonio de valores en la mayoría de distribuciones
# de Linux no puede hacer eso. oidentd es un paquete que pueda.
# Consultar: http://dev.ojnk.net/
"
			: ''
		)
		: '';

	// NTP server on gateway
	print ( $NTP_IN )
		? "
# Network Time Protocol (NTP) Server
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 123 -j ACCEPT
"
		: '';

	// DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# servidor DNS
# Configurar el servidor para utilizar el puerto 53 como el puerto de origen
# de las solicitudes. Nota, si ejecuta un servidor de nombres de sólo caché
# que sólo acepta consultas de la red privada o localhost, puede comentar la línea.
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 53 -j ACCEPT

# Si no consultar de código del servidor para el puerto 53 y tienes problemas,
# elimine esta regla. Permite específicamente las respuestas a las consultas
# iniciadas con otro servidor de un alto el puerto UDP. Las normas de conexión
# con estado deben manejar esta situación, sin embargo.
#\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// If running a DHCP server on the Internet interface, allow the requests
	print ( $DHCP_IN )
		? "
# Externa Servidor DHCP
# Permitir paquetes de solicitud de cliente DHCP entrantes desde la red externa
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
		: '';
	// If it's a dynamic address, set rule to allow inbound DHCP
	print ( $DYNAMIC_IP )
		? "
# Dinámica Dirección
# Si DHCP, la solicitud inicial es una emisión. La respuesta no coincide
# exactamente con el paquete saliente. La siguiente permite explícitamente
# los puertos DHCP para aliviar este problema. Si usted recibe su dirección
# dinámica por un medio diferente, es probable que pueda comentar esta línea.
\$IPT -A udp_inbound -p UDP -s 0/0 --source-port 67 --destination-port 68 \\
     -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Sistema de archivos de red (NFS) Servidor
# Tenga en cuenta que los servicios adicionales se deben configurar con
# el fin de apoyar a un servidor NFS a través del firewall. Lea la ayuda
# en el generador o en este sitio:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 111 -j ACCEPT

# NFS Server - statd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# NFS Server - NFS daemon
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port 2049 -j ACCEPT

# NFS Server - lockd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# NFS Server - mountd
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# NFS Server - quotad
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_UDP )
		? "
# Usuario especificado protocolo UDP permitido
\$IPT -A udp_inbound -p UDP -s 0/0 --destination-port $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# No coincide, por lo que volver para el registro
$IPT -A udp_inbound -p UDP -j RETURN

###############################################################################
#
# cadena udp_outbound
#
# Esta cadena se utiliza con una red privada para evitar el reenvío de
# solicitudes UDP en protocolos específicos. Aplicado a la regla FORWARD
# de la red interna. Termina con una ACCEPT (aceptar)

<?php
	// If IM blocked, block ICQ, which uses UDP 4000
	print ( $IM_OUT )
		? "
# ICQ utiliza UDP 4000 - Mensajería instantánea bloqueado
\$IPT -A udp_outbound -p UDP -s 0/0 --destination-port 4000 -j REJECT
"
		: '';
?>

# No match, so ACCEPT
$IPT -A udp_outbound -p UDP -s 0/0 -j ACCEPT

###############################################################################
#
# cadena tcp_inbound
#
# Esta cadena se utiliza para permitir conexiones entrantes en el sistema
# / gateway. Usar con cuidado. Por defecto es NONE (ninguno).
# Se aplica en las aportaciones de la interfaz externa / Internet.

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Permitir a sí mismo a través de (a static IP / CIDR es mejor)
# Para reducir el acceso permitido, elimine esta regla y comentar la regla INPUT
# (A continuación, añadir o eliminar los puertos según sea necesario)
#\$IPT -A tcp_inbound -p TCP -s \$MY_CIDR -m multiport --destination-ports 21,22 -j ACCEPT
"
	: '';

	// Reject ident requests. IRC User
	print ( $IRC_USER )
		? "
# Peticiones IRC Ident (puerto 113) deben tener una regla de rechazo y no
# la regla DROP por defecto. Este es el requisito mínimo para evitar
# retrasos largos durante la conexión. Véase también la regla udp_inbound.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j REJECT

# Una configuración más sofisticada podría aceptar las peticiones ident.
#\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 113 -j ACCEPT
".		(( $GATEWAY )
			? "
# Sin embargo, si se trata de un sistema de puerta de enlace que se disfraza
# / nats para los sistemas internos y los sistemas internos desean charlar,
# un simple cambio de estas reglas para ACEPTAR no funcionará. El demonio
# ident en la puerta de entrada tendrá que saber cómo manejar las peticiones.
# El demonio de valores en la mayoría de distribuciones de Linux no puede
# hacer eso. oidentd es un paquete que pueda.
# Consultar: http://dev.ojnk.net/
"
			: ''
		)
		: '';

//DNS Server - TCP (most are UDP, so this could be disabled)
	print ( $DNS_IN )
		? "
# Servidor DNS - Permitir conexiones TCP (transferencias de zona y las
# solicitudes de las grandes) Esto está desactivada por defecto.
# Las transferencias de zona DNS se producen a través de TCP.
# Si necesita permitir las transferencias sobre la red que necesita para
# descomentar esta línea. Si usted permite que las preguntas de la 'red,
# también hay que tener en cuenta que aunque las consultas DNS utilizan UDP
# por defecto, una consulta UDP truncada puede legalmente ser presentada a
# través de TCP en lugar. Probablemente nunca lo necesita, pero debe ser
# consciente de este hecho.
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 53 -j ACCEPT
"
		: '';

	// mDNSResponder
	print ( $MDNSRESPONDER_IN )
		? "
# mDNSResponder
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 5353 -j ACCEPT
"
		: '';

	// HTTP
	print ( $HTTP_IN )
		? "
# HTTP Web Server
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 80 -j ACCEPT
"
		: '';

	// HTTPS
	print ( $HTTPSSL_IN )
		? "
# HTTPS (Secure Web Server)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 443 -j ACCEPT
"
		: '';

	if( $FTP_IN ) {
		// FTP
		print "
# FTP Server (Control)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 21 -j ACCEPT

# Cliente FTP (Puerto de datos para las transferencias no PASV)
\$IPT -A tcp_inbound -p TCP -s 0/0 --source-port 20 -j ACCEPT

# FTP pasivo
#
# Con FTP pasivo, el servidor proporciona un puerto para el cliente y permite
# que el cliente inicia la conexión en lugar de iniciar la conexión con
# el cliente desde el puerto de datos. Navegadores Web y clientes que operan
# detrás de un firewall en general, utilizar las transferencias FTP pasivas.
# Un servidor de propósito general FTP tendrá que apoyarlos.
#
# Sin embargo, por defecto un servidor FTP se seleccione un puerto de toda
# la gama de puertos altos. No es particularmente seguro para abrir todos
# los puertos altos. Afortunadamente, ese rango puede ser restringido.
# Este firewall presume que la gama se ha restringido a un rango seleccionado
# específico. Ese rango también se debe configurar en el servidor ftp.
#
# Las instrucciones para especificar el rango de puerto para el servidor
# de wu-ftpd se pueden encontrar aquí:
# http://www.wu-ftpd.org/man/ftpaccess.html
# (Véase la opción de puertos pasivos.)
#
# Instrucciones para el servidor ProFTPD se pueden encontrar aquí:
# http://proftpd.linux.co.uk/localsite/Userguide/linked/x861.html
";

		// Passive FTP
		print ( $PASSIVE_IN )
			? "
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $PASSIVE_PORT_FROM:$PASSIVE_PORT_TO -j ACCEPT
"
			: "
# Regla de la muestra
# \$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 62000:64000 -j ACCEPT
";
	}

	// Email
	print ( $EMAIL_IN )
		? "
# Servidor de correo electrónico (SMTP)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 25 -j ACCEPT

# Servidor de correo electrónico (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 110 -j ACCEPT

# Servidor de correo electrónico (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 143 -j ACCEPT
"
		: '';

	print ( $EMAILSSL_IN )
		? "
# SSL Servidor de correo electrónico (POP3)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 995 -j ACCEPT

# SSL Servidor de correo electrónico (IMAP4)
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 993 -j ACCEPT
"
		: '';

	// SSH
	print ( $SSH_IN )
		? "
# SSH
# MH ayuda: como se suministra, la siguiente línea permite conexiones ssh
# desde cualquier fuente ('-s 0/0'). Así se llegará a cientos de conexiones
# diarias desde IPs que intentan ataques de diccionario en su dispositivo.
# Si es posible, se recomienda encarecidamente a colocar su propio IP / CIDR
# allí en vez: por ejemplo, '-s \$MY_IP' or '-s \$MY_CIDR'.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 22 -j ACCEPT
"
		: '';

	// ICQ
	print ( $IM_IN )
		? "
# ICQ transferencias de archivos y otras funciones avanzadas
#
# ICQ apoya una serie de opciones más allá de la mensajería instantánea
# simple. Para aquellos con la función, el sistema de mensajería instantánea
# debe permitir nuevas conexiones iniciadas desde sistemas remotos. Esta
# opción se abrirá un rango de puerto especificado en el sistema de servidor
# de seguridad. El cliente ICQ en el sistema de servidor de seguridad también
# debe estar configurado para utilizar el rango de puerto especificado.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $IM_PORT_FROM:$IM_PORT_TO -j ACCEPT
"
		: '';

	// MSN Messenger
	print ( $MESSENGER_IN )
		? "
# Transferencias de Archivos de MSN Messenger
#
# Messenger admite transferencias de archivos. Para las transferencias
# iniciadas por los sistemas remotos a la función, el sistema debe permitir
# nuevas conexiones iniciadas desde sistemas remotos un rango de puerto
# específico. Defecto esta opción para el intervalo de puertos 6891 a través
# de 6900. A menos que el cliente de MSN Messenger puede estar configurado
# para especificar cualquier rango de puertos, no cambie el valor predeterminado.
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MSN_PORT_FROM:$MSN_PORT_TO -j ACCEPT
"
		: '';

	// Inbound NFS selected
	print ( $NFS_IN )
		? "
# Sistema de archivos de red (NFS) Servidor
#
# Tenga en cuenta que los servicios adicionales se deben configurar con el fin
# de apoyar a un servidor NFS a través del firewall. Lea la ayuda en el
# generador o en este sitio:
# http://www.lowth.com/LinWiz/nfs_help.html

# NFS Server - portmapper
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 111 -j ACCEPT

# Servidor NFS - statd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $STATD_PORT -j ACCEPT

# Servidor NFS - NFS daemon
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port 2049 -j ACCEPT

# Servidor NFS - lockd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $LOCKD_PORT -j ACCEPT

# Servidor NFS - mountd
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $MOUNTD_PORT -j ACCEPT

# Servidor NFS - quotad
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port $RQUOTAD_PORT -j ACCEPT
"
		: '';

	// User specified inbound rule
	print ( $OTHER_IN and $OTHER_IN_TCP )
		? "
# Usuario especificado protocolo TCP permitido
\$IPT -A tcp_inbound -p TCP -s 0/0 --destination-port  $OTHER_IN_FROM".
(( empty( $OTHER_IN_TO )) ? '' : ":$OTHER_IN_TO")." -j ACCEPT
"
		: '';
?>

# No coincide, por lo que volver por lo que se registrará
$IPT -A tcp_inbound -p TCP -j RETURN

###############################################################################
#
# cadena tcp_outbound
#
# Esta cadena se utiliza con una red privada para evitar el reenvío de las
# solicitudes en protocolos específicos. Aplicado a la regla FORWARD de la
# red interna. Termina con una ACCEPT (aceptar)

<?php
	// IRC
	print ( $IRC_OUT )
		? "
# Bloquear IRC
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 194 -j REJECT
"
		: '';

	// telnet
	print ( $TELNET_OUT )
		? "
# Telnet Bloque de Salida
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 23 -j REJECT
"
		: '';

	// ssh
	print ( $SSH_OUT )
		? "
# Bloquear SSH
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 22 -j REJECT
"
		: '';

	// usenet
	print ( $NEWS_OUT )
		? "
# Bloquee Usenet Acceso
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 119 -j REJECT
"
		: '';

	// web
	print ( $HTTP_OUT )
		? "
# Bloquear Acceso Web
# HTTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 80 -j REJECT

# HTTPS (Secure Web)
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 443 -j REJECT
"
		: '';

	// ftp
	print ( $FTP_OUT )
		? "
# Bloquear el Acceso FTP
# Control
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 21 -j REJECT

# datos
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 20 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $IM_OUT )
		? "
# Bloquear Mensajería Instantánea
# AIM
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 5190 -j REJECT

# AIM Imágenes
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 4443 -j REJECT

# MSN Messenger
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 1863 -j REJECT
"
		: '';

	// Instant Messaging
	print ( $EMAIL_OUT )
		? "
# Bloquee Email El acceso a servidores externos
# SMTP
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 25 -j REJECT

# POP3
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 110 -j REJECT

# IMAP4
\$IPT -A tcp_outbound -p TCP -s 0/0 --destination-port 143 -j REJECT
"
		: '';
?>

# No hay resultados, por lo ACCEPT (aceptar)
$IPT -A tcp_outbound -p TCP -s 0/0 -j ACCEPT

###############################################################################
#
# Chain INPUT
#

echo "Cadena de proceso de las INPUT (entradas) ..."

# Permitir todo en la interfaz localhost
$IPT -A INPUT -p ALL -i $LO_IFACE -j ACCEPT

# Caiga paquetes defectuosos
$IPT -A INPUT -p ALL -j bad_packets

# DOCSIS cable módems compatibles
# Algunos módems por cable compatibles con DOCSIS enviar multicast IGMP para
# encontrar los PCs conectados. Los paquetes de multidifusión 224.0.0.1 tienen
# la dirección de destino. Usted puede aceptarlas. Si decide hacerlo, elimine
# la regla a aceptarlas (ACCEPT) y comentar la regla a soltarlos (DROP).
# El firewall dejarlos aquí por defecto para evitar llenar el registro.
# El firewall se retiren todos multidifusiones a toda la subred (224.0.0.1)
# de forma predeterminada. Para sólo afectan multidifusiones IGMP, el cambio
# '-p all' para '-p 2'. Por supuesto, si no son aceptados en otro lugar,
# un viaje de solo garantizar que las multidifusiones en otros protocolos
# se registran.
#
# Dejarlos sin registro.
$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# La regla de aceptar los paquetes.
# $IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT

<?php
	if( $GATEWAY ) {
		// Rules for the private network
		print "
# Reglas para la red privada
# (sistema de puerta de enlace para acceder a sí mismo)
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -s \$LOCAL_NET -j ACCEPT
\$IPT -A INPUT -p ALL -i \$LOCAL_IFACE -d \$LOCAL_BCAST -j ACCEPT
";

		// If running DHCP internally from this server, also allow dhcp client requests
		print ( $INTERNAL_DHCP )
			? "
# Permitir paquetes de solicitud de cliente DHCP entrantes desde la red interna
\$IPT -A INPUT -p UDP -i \$LOCAL_IFACE --source-port 68 --destination-port 67 \\
     -j ACCEPT
"
			: '';
	}
?>

# Entrantes Internet Packet Reglas

# Aceptar Conexiones Establecidas
$IPT -A INPUT -p ALL -i $INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

<?php
	// allow own IP/CIDR through
print ( $SELF_IN )
	? "
# Permitir a sí mismo a través de (a static IP / CIDR es mejor)
# A la entrega, esta regla permite el acceso a todos los puertos a \$MY_CIDR
# Para reducir el acceso permitido, comenta esta regla y descomentar
# la regla tcp_inbound
\$IPT -A INPUT -p TCP -s \$MY_CIDR   -j ACCEPT
"
	: '';
?>

# Pase el resto de la cadena de usuario correspondiente
$IPT -A INPUT -p TCP -i $INET_IFACE -j tcp_inbound
$IPT -A INPUT -p UDP -i $INET_IFACE -j udp_inbound
$IPT -A INPUT -p ICMP -i $INET_IFACE -j icmp_packets

# Deja sin iniciar las transmisiones que llegan hasta aquí.
# Reduce el desorden de registro. Comentar esta línea si el ensayo de nuevas
# normas que los protocolos de transmisión de impacto.
$IPT -A INPUT -m pkttype --pkt-type broadcast -j DROP

# Entrar paquetes que aún no coinciden
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "
\$IPT -A INPUT -j LOG --log-prefix \"fp=INPUT:99 a=DROP \"
"
		: "
\$IPT -A INPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"INPUT packet died: \"
";
?>

###############################################################################
#
# Cadena FORWARD
#

echo "Cadena FORWARD proceso ..."

# Se utiliza si el reenvío para una red privada

<?php
	if( $GATEWAY ) {
		// private network exists
		print "
# Caiga paquetes defectuosos
\$IPT -A FORWARD -p ALL -j bad_packets

# Aceptar paquetes TCP que deseamos transmitir a partir de fuentes internas
\$IPT -A FORWARD -p tcp -i \$LOCAL_IFACE -j tcp_outbound

# Aceptar paquetes UDP que deseamos transmitir a partir de fuentes internas
\$IPT -A FORWARD -p udp -i \$LOCAL_IFACE -j udp_outbound

# Si no está bloqueado, aceptar cualquier otro paquetes de la interfaz interna
\$IPT -A FORWARD -p ALL -i \$LOCAL_IFACE -j ACCEPT

# Encaja con las respuestas de la internet
\$IPT -A FORWARD -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \\
     -j ACCEPT

";

		// If port forwarding option selected, the forward chain must also
		// accept the port forwarding.
		// one/both of PORT_FORWARD_TCP and/or PORT_FORWARD_UDP *must* be selected
		print ( $PORT_FORWARD and $PORT_FORWARD_UDP )
			? "
# Port Forwarding está habilitada, por lo que acepta el tráfico reenviado
\$IPT -A FORWARD -p udp -i \$INET_IFACE --destination-port ".		(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print ( $PORT_FORWARD and $PORT_FORWARD_TCP )
			? "
\$IPT -A FORWARD -p tcp -i \$INET_IFACE --destination-port ".
			(
				(( empty( $PORT_FORWARD_IPORT ))
					? ( $PORT_FORWARD_FROM . (( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO"))
					: $PORT_FORWARD_IPORT
				) ." \\\n     --destination $PORT_FORWARD_IP -j ACCEPT\n\n"
			)
			: '';

		print "# Entrar paquetes que aún no coinciden";

		// Check LOG_FIREPARSE to determine log-prefix format
		print ( $LOG_FIREPARSE )
			? "
\$IPT -A FORWARD -j LOG --log-prefix \"fp=FORWARD:99 a=DROP \"
"
			: "
\$IPT -A FORWARD -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"FORWARD packet died: \"
";
	}
?>

###############################################################################
#
# cadena OUTPUT (salida)
#

echo "Cadena OUTPUT (salida) proceso ..."

# Confiar en lo general, el servidor de seguridad en la salida

# Sin embargo, los paquetes ICMP no válidos deben ser dejados para
# evitar un posible exploit.
$IPT -A OUTPUT -m state -p icmp --state INVALID -j DROP

# Localhost
$IPT -A OUTPUT -p ALL -s $LO_IP -j ACCEPT
$IPT -A OUTPUT -p ALL -o $LO_IFACE -j ACCEPT

<?php
	// If private network exists
	print ( $GATEWAY )
		? "
# Para red interna
\$IPT -A OUTPUT -p ALL -s \$LOCAL_IP -j ACCEPT
\$IPT -A OUTPUT -p ALL -o \$LOCAL_IFACE -j ACCEPT

"
		: '';
?>
# Para Internet
$IPT -A OUTPUT -p ALL -o $INET_IFACE -j ACCEPT

# Entrar paquetes que aún no coinciden
<?php
	// Check LOG_FIREPARSE to determine log-prefix format
	print ( $LOG_FIREPARSE )
		? "\$IPT -A OUTPUT -j LOG --log-prefix \"fp=OUTPUT:99 a=DROP \""
		: "\$IPT -A OUTPUT -m limit --limit 3/minute --limit-burst 3 -j LOG \\
    --log-prefix \"OUTPUT packet died: \"";
?>


###############################################################################
#
# tabla nat
#
###############################################################################

# La tabla nat es donde se produce la traducción de direcciones de red, si hay
# una red privada. Si la puerta de enlace se conecta a Internet con una
# dirección IP estática, se utiliza snat. Si la puerta de enlace tiene una
# dirección dinámica, mascarada debe ser utilizado en su lugar. Hay más
# sobrecarga asociada con la mascarada, por lo snat es mejor cuando se puede
# utilizar. La tabla nat tiene una cadena montada, PREROUTING, por dnat y
# redirecciones. Otra, POSTROUTING, maneja snat y disfraces.

echo "Normas de carga para la tabla nat ..."

###############################################################################
#
# cadena PREROUTING
#
<?php
	if( $PORT_FORWARD ) {
		// port forwarding option selected, build the rule here
		print "
# Port Forwarding

# Expedición portuaria reenvía todo el tráfico de un puerto o los puertos del
# servidor de seguridad para un ordenador de la LAN interna. Esto puede ser
# necesario para apoyar situaciones especiales. Por ejemplo, esta es la única
# manera de apoyar las transferencias de archivos con un cliente ICQ en un
# ordenador interno. También es necesario si un sistema interno alberga un
# servicio como un servidor web. Sin embargo, también es una opción peligrosa.
# Permite el acceso de Internet a los ordenadores de la red interna. Úsalo con
# cuidado y sólo si está seguro de que sabes lo que estás haciendo.
";

		print ( $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$INET_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_UDP )
			? "
\$IPT -t nat -A PREROUTING -p udp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		print ( $PORT_FORWARD_REDIR and $PORT_FORWARD_TCP )
			? "
\$IPT -t nat -A PREROUTING -p tcp -i \$LOCAL_IFACE --destination-port $PORT_FORWARD_FROM".
(( empty( $PORT_FORWARD_TO )) ? '' : ":$PORT_FORWARD_TO") ." \\
     --destination \$INET_ADDRESS -j DNAT --to-destination $PORT_FORWARD_IP".
(( empty( $PORT_FORWARD_IPORT )) ? '' : ":$PORT_FORWARD_IPORT")."
"
			: '';

		// If TRANSPARENT_PROXY option set, redirect port 80 and port 443 to the
		// REDIRECT_PORT on the gateway machine
		print ( $TRANSPARENT_PROXY )
			? "
# Esta es una muestra de que eximir a un host específico desde el
# proxy transparente
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 80 \\
#     -j RETURN
#\$IPT -t nat -A PREROUTING -p tcp -s 192.168.1.50 --destination-port 443 \\
#     -j RETURN

# Redirigir HTTP para un proxy transparente
\$IPT -t nat -A PREROUTING -p tcp --destination-port 80 \\
     -j REDIRECT --to-ports $REDIRECT_PORT

# Redireccionar HTTPS para un proxy transparente - comentada por defecto
# \$IPT -t nat -A PREROUTING -p tcp --destination-port 443 \\
#     -j REDIRECT --to-ports $REDIRECT_PORT
"
			: '';
	}
?>

###############################################################################
#
# cadena POSTROUTING
#

<?php
	//If it's a gateway then install either snat or masquerade.
	print ( $GATEWAY )
		? (( $DYNAMIC_IP )	// masquerade or snat
			? "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE -j MASQUERADE\n"
			: "\$IPT -t nat -A POSTROUTING -o \$INET_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS\n".
			(( $PORT_FORWARD_REDIR )
				? "\$IPT -t nat -A POSTROUTING -o \$LOCAL_IFACE \\
     -j SNAT --to-source \$INET_ADDRESS
"
				: ''
			)
		)
		: '';
?>

###############################################################################
#
# tabla mangle
#
###############################################################################

# La tabla mangle se utiliza para modificar los paquetes. Se puede alterar o
# mangle ellos de varias maneras. A los efectos de este generador, sólo
# utilizamos su capacidad de alterar el TTL de los paquetes. Sin embargo,
# se puede utilizar para establecer valores de marca de netfilter en los
# paquetes específicos. Esas marcas se podrían utilizar entonces en otra tabla
# como filtro, para limitar las actividades asociadas a un host específico,
# por ejemplo. El objetivo TOS se puede utilizar para establecer el campo
# Tipo de Servicio en el encabezado IP. Tenga en cuenta que el objetivo TTL
# puede no estar incluido en la distribución en el sistema. Si no lo está y
# usted quiere, usted tendrá que agregarlo. Esto puede requerir que se
# construye desde el código fuente.

echo "Normas de carga para la tabla mangle ..."
<?php
	// Reset the TTL if requested to do so.
	print ( $MANGLE_TTL )
		? "
# Ajuste el TTL en paquetes de salida en el mismo valor constante. Un valor
# de alrededor de 128 es un buen valor. No establezca esta demasiado alto, ya
# que afectará negativamente a su red. También se considera de mala educación
# en Internet.
\$IPT -t mangle -A OUTPUT -o \$INET_IFACE -j TTL --ttl-set $TTL
"
		: '';
// vi: shiftwidth=3 tabstop=3 et
?>
